#ifndef H_ACCOUNT_H
#define H_ACCOUNT_H

#include <fstream.h>
#include "tag.h"
#include "htmlstream.h"

class Account
{
public:
	friend istream &operator>>(istream &i, Account &a){
		// Load lines until one of the following:
		// 	eof
		// 	isEnd
		// 	<BANKID>
		// 	<ACCTID>
		// 	<ACCTTYPE>
		char *Buffer = new char[255];
		string temp;
		while(!i.eof()){
			i.getline(Buffer,255);
			temp = FixLine(Buffer);
								
			if (a.isEnd(temp))
				break;

			Tag t;
			if (t.isTag(temp,"<BANKID>"))
				a.Bank_ID = t.loadTag(temp,"<BANKID>");
			if (t.isTag(temp,"<ACCTID>"))
				a.Account_ID = t.loadTag(temp,"<ACCTID>");
			if (t.isTag(temp,"<ACCTTYPE>"))
				a.Account_Type = t.loadTag(temp,"<ACCTTYPE>");
			
		}
		delete Buffer;
		return i;
	}
	
	friend htmlstream &operator<<(htmlstream &o, Account &a){
		// Just print it out
		o << "<TABLE BGCOLOR=\"#A0A0FF\">\n";
		o << "<TR>\n";
		o << "<TD><B>Account ID</B></TD>\n";
		o << "<TD>" << a.Account_ID << "</TD>\n";
		o << "</TR>\n";
		o << "<TR>\n";
		o << "<TD><B>Bank ID</B></TD>\n";
		o << "<TD>" << a.Bank_ID << "</TD>\n";
		o << "</TR>\n";
		o << "<TR>\n";
		o << "<TD><B>Account Type</B></TD>\n";
		o << "<TD>" << a.Account_Type << "</TD>\n";
		o << "</TR>\n";
		o << "</TABLE>\n";	
		return o;
	}

	int 	isStart(string Line){
		return (Line == "<BANKACCTFROM>");
	}
	
	int		isEnd(string Line){
		return (Line == "</BANKACCTFROM>");
	}

	string	Bank_ID;
	string	Account_ID;
	string 	Account_Type;
};



#endif // H_ACCOUNT_H