#ifndef H_BALANCE_H
#define H_BALANCE_H

#include <fstream.h>
#include <iomanip.h>
#include "htmlstream.h"

class Balance
{
public:

	friend istream &operator>>(istream &i, Balance &b ){
		// Load lines until:
		// 	eof
		// 	isEnd
		// 	<BALAMT>
		// 	<DTASOF>	
		char *Buffer = new char[255];
		string temp;
		while(!i.eof()){
			i.getline(Buffer,255);
			temp = FixLine(Buffer);
								
			if (b.isEnd(temp))
				break;

			Tag t;
			if (t.isTag(temp,"<BALAMT>"))
				t.loadTag(temp,"<BALAMT>",b.fBalance);
			if (t.isTag(temp,"<DTASOF>"))
				b.Date_As_Of = t.loadTag(temp,"<DTASOF>");
			
		}
		delete Buffer;
		return i;
	}

	friend htmlstream &operator<<(htmlstream &o, Balance &b){
		// Just print it out
		o << "Balance: ";
		o.form("$%5.2f", b.fBalance);
		o << " as of " << FixedDate(b.Date_As_Of) << "<BR>\n";
		return o;
	}
	

	virtual int		isStart(string Line) = NULL;
	virtual int		isEnd(string Line) = NULL;
	
	float	fBalance;
	string	Date_As_Of;
};




#endif //H_BALANCE_H