#ifndef H_STATEMENT_TRANSMISSION_H
#define H_STATEMENT_TRANSMISSION_H


#include <fstream.h>
#include "htmlstream.h"
#include "account.h"
#include "trans_stmt.h"
#include "ledger_bal.h"
#include "avail_bal.h"
#include "tag.h"


class StatementTransmission
{
public:

	friend istream &operator>>(istream &i, StatementTransmission &st){
		// Load lines until any of the following:
		// 		End of File				
		// 		isEnd
		// 		myAccount.isStart
		// 		myAccountStatement.isStart
		// 		myLedgerBalance.isStart
		// 		myAvailableBalance.isStart
		//		<CURDEF> tag is recognized
		char *Buffer = new char[255];
		string temp;
		while(!i.eof()){
			i.getline(Buffer,255);
			temp = FixLine(Buffer);
								
			if (st.isEnd(temp))
				break;
			if (st.myAccount.isStart(temp)){
				cout << "Account information.\n";
				i >> st.myAccount;
				continue;
			}
			if (st.myAccountStatement.isStart(temp)){
				cout << "Statement information.\n";
				i >> st.myAccountStatement;
				continue;
			}
			if (st.myLedgerBalance.isStart(temp)){
				cout << "Ledger Balance information.\n";
				i >> st.myLedgerBalance;
				continue;
			}
			if (st.myAvailableBalance.isStart(temp)){
				cout << "Available Balance information.\n";
				i >> st.myAvailableBalance;
				continue;
			}
			Tag t;
			if (t.isTag(temp,"<CURDEF>"))
				st.Cur_Def = t.loadTag(temp,"<CURDEF>");		
		}
		
		delete Buffer;
		return i;
	}

	friend htmlstream &operator<<(htmlstream &o, StatementTransmission &st){
		o << "Beginning of Statement Transmission<BR>\n";
		o << "<HR>\n";
		o << "Account:<BR>\n";
		o << st.myAccount;
		o << "<HR>\n";
		o << st.myAccountStatement;
		o << "<HR>\n";
		o << st.myLedgerBalance;
		o << "<HR>\n";
		o << st.myAvailableBalance;
		o << "<HR>\n";
		o << "End of Statement Transmission<BR>\n";		
		return o;
	}	

	int 	isStart(string Line){
		return (Line == "<STMTRS>");
	}

	int 	isEnd(string Line){
		return (Line == "</STMTRS>");
	}

	string					Cur_Def;

	Account					myAccount;	
	TransactionStatement	myAccountStatement;
	LedgerBalance 			myLedgerBalance;
	AvailableBalance 		myAvailableBalance;
};




#endif //H_STATEMENT_TRANSMISSION_H