#ifndef H_TRANSACTION_STATEMENT_H
#define H_TRANSACTION_STATEMENT_H

#include <fstream.h>
#include <g++/deque.h>
#include "tag.h"
#include "htmlstream.h"
#include "transaction.h"

typedef deque<Transaction> TransactionList;

class TransactionStatement
{
public:

	friend istream &operator>>(istream &i,TransactionStatement &ts){
		// Load lines until on of the following:
		// 		eof
		// 		isEnd
		// 		Transaction::isStart
		//		<DTSTART>
		//		<DTEND>

		char *Buffer = new char[255];
		string temp;
		while(!i.eof()){
			i.getline(Buffer,255);
			temp = FixLine(Buffer);
								
			if (ts.isEnd(temp))
				break;

			Transaction foo;
			if (foo.isStart(temp)){
				i >> foo;
				ts.Transactions.push_back(foo);	
			}

			Tag t;
			if (t.isTag(temp,"<DTSTART>"))
				ts.Start_Date = t.loadTag(temp,"<DTSTART>");
			if (t.isTag(temp,"<DTEND>"))
				ts.End_Date = t.loadTag(temp,"<DTEND>");
			
		}
		delete Buffer;
		return i;
	}

	friend htmlstream &operator<<(htmlstream &o, TransactionStatement &ts){
		
		// Do a table here and iterate through all Transactions
		o << "Transactions starting " << FixedDate(ts.Start_Date);
		o << " and ending " << FixedDate(ts.End_Date) <<  "\n";
		o << "<TABLE BORDER=\"1\" BGCOLOR=\"#FFFFFF\">\n";
		o << "<TR>\n";
		o << "<TD ALIGN=\"CENTER\"><B>Transaction Type</B></TD>\n";
		o << "<TD ALIGN=\"CENTER\"><B>Date Posted</B></TD>\n";
		o << "<TD ALIGN=\"CENTER\"><B>Memo</B></TD>\n";
		o << "<TD ALIGN=\"CENTER\"><B>Name</B></TD>\n";
		o << "<TD ALIGN=\"CENTER\"><B>Transaction Amount</B></TD>\n";
		o << "</TR>\n";
		
		for(int x=0;x<ts.Transactions.size();x++)
		o << ts.Transactions[x];
		
		o << "</TABLE>\n";
	}

	int		isStart(string Line){
		return (Line == "<BANKTRANLIST>");
	}
	
	int 	isEnd(string Line){
		return (Line == "</BANKTRANLIST>");
	}
	
	string	Start_Date;
	string	End_Date;

	TransactionList 	Transactions;
};


#endif //  H_TRANSACTION_STATEMENT_H