#ifndef H_TRANSACTION_H
#define H_TRANSACTION_H

#include <fstream.h>
#include <g++/string>
#include "tag.h"
#include "htmlstream.h"

class Transaction
{
public:

	friend istream &operator>>(istream &i, Transaction &tt){
		// Load lines until:
		// 		eof
		// 		isEnd
		// 		<TRNTYPE>
		// 		<DTPOSTED>
		// 		<TRNAMT>
		// 		<FITID>
		// 		<NAME>
		// 		<MEMO>
		char *Buffer = new char[255];
		string temp;
		while(!i.eof()){
			i.getline(Buffer,255);
			temp = FixLine(Buffer);
								
			if (tt.isEnd(temp))
				break;

			Tag t;
			if (t.isTag(temp,"<TRNTYPE>"))
				tt.Transaction_Type = t.loadTag(temp,"<TRNTYPE>");
			if (t.isTag(temp,"<DTPOSTED>"))
				tt.Date_Posted = t.loadTag(temp,"<DTPOSTED>");
			if (t.isTag(temp,"<MEMO>"))
				tt.Memo = t.loadTag(temp,"<MEMO>");
			if (t.isTag(temp,"<NAME>"))
				tt.Name = t.loadTag(temp,"<NAME>");
			if (t.isTag(temp,"<FITID>"))
				tt.Fit_ID = t.loadTag(temp,"<FITID>");
			if (t.isTag(temp,"<TRNAMT>"))
				t.loadTag(temp,"<TRNAMT>",tt.Transaction_Amount);
			
		}
		delete Buffer;
		return i;
	}
	
	friend htmlstream &operator<<(htmlstream &o, Transaction &t){
		// Display each item as a <TR> <TD>Item</TD>... </TR>
		// Transaction Statement will handle the TABLE 
		o << "<TR>\n";
		o << "<TD>" << t.Transaction_Type << "</TD>\n";
		o << "<TD>" << FixedDate(t.Date_Posted) << "</TD>\n";
		o << "<TD>" << t.Memo << "</TD>\n";
		o << "<TD>" << t.Name << "</TD>\n";
		o << "<TD ALIGN=\"RIGHT\">";
		o.form("$%5.2f",t.Transaction_Amount);
		o << "</TD>\n";
		o << "</TR>\n";
		return o;
	}



	int		isStart(string Line){
		return (Line == "<STMTTRN>");
	}

	int		isEnd(string Line){
		return (Line == "</STMTTRN>");
	}

	string 	Transaction_Type;
	string 	Date_Posted;
	string	Memo;
	float	Transaction_Amount;
	string	Fit_ID;
	string	Name;
};


#endif // H_TRANSACTION_H
